SystemOrganization addCategory: #GODProcessors!

Object subclass: #PCSGODTagger
	instanceVariableNames: 'tagger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:36'!
addTagsTo: aGodData
 
	|tags|

	" Get most relevants tokens in aGodData and add it as tags of aGodData "
	
	tags := (tagger getMoreRelevantsOf: aGodData content) asOrderedCollection.
	aGodData tags: tags.! !

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:35'!
initialize

	"define a standard configuration to the algorithm"
	tagger := PCSTagger new.! !

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:49'!
tagCollection: aGODDataCollection

	self training: aGODDataCollection.
	aGODDataCollection do: [ :element |
		self addTagsTo: element
  	].! !

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:52'!
tagger
	"get tagger"
	^tagger.! !

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:52'!
tagger: value
	"set tagger"
	tagger := value.! !

!PCSGODTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 17:36'!
training: aGODDataCollection
	|aStringCollection|
	
  	"it extracts the aGODDataCollection's contents"
	aStringCollection := Bag new.
  	aGODDataCollection do: [ :aElement |
		aStringCollection add: aElement content.
    	].
  	"it trains the algorithm with the given aGODDataCollection contents"
	tagger createDictIdf: aStringCollection.! !

Object subclass: #PCSProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSProcessor commentStamp: 'FKP 11/2/2014 19:21' prior: 0!
A PCSProcessor is a class that processes strings, by count of ocurrences.

Instance Variables: none
!

PCSProcessor subclass: #PCSPreprocessor
	instanceVariableNames: 'fileType punctuation removeStopWords languageStopWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSPreprocessor commentStamp: 'TD 11/16/2014 17:12' prior: 0!
A PCSPreprocessor is xxxxxxxxx.

Instance Variables
	fileType:	<String>
		

fileType
	-Defines the type of arquive that is treated
	May be one of two types:
		-'TXT': a commom file 
		-'HTML': a HTML file

!

PCSPreprocessor subclass: #PCSEnglishPreprocessor
	instanceVariableNames: 'fileType stopWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSEnglishPreprocessor methodsFor: 'initialize-release' stamp: 'FKP 11/17/2014 19:10'!
initialize
	"define a standard configuration to the stopwords in English"
	
	stopWords := #('about' 'above' 'after' 'again' 'all' 'also') asSet. ! !

!PCSEnglishPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 18:23'!
stopWords
	"get stopWods"

	^stopWords.! !

!PCSEnglishPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 13:53'!
stopWords: aCollectionStopWords
	"set stopWords"

	stopWords := aCollectionStopWords.! !

PCSPreprocessor subclass: #PCSPortuguesePreprocessor
	instanceVariableNames: 'fileType stopWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSPortuguesePreprocessor methodsFor: 'initialize-release' stamp: 'FKP 11/17/2014 19:10'!
initialize
	"define a standard configuration to the stopwords in Portuguese"
	
	stopWords := #('agora' 'acerca' 'antes' 'qual' 'qualquer' 'tal' 'tambm' 'mais') asSet.! !

!PCSPortuguesePreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 16:13'!
stopWords
	"get stopWords"
	
	^stopWords.! !

!PCSPortuguesePreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 16:15'!
stopWords: aCollectionStopWords
	"set stopWords"
	
	stopWords := aCollectionStopWords.! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'TD 11/16/2014 11:27'!
fileType
	"get fileType"
	^fileType. ! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'TD 11/16/2014 11:27'!
fileType: value
	"set fileType"
	fileType := value.! !

!PCSPreprocessor methodsFor: 'initialize-release' stamp: 'FKP 11/17/2014 19:44'!
initialize

	"define a standard configuration to the preprocessor"
	fileType := 'TXT'.
	punctuation := '?!!.,:;()[]{}%$#+='. 
	removeStopWords := true. "remove for default"
	languageStopWords := 'English'.! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 15:59'!
languageStopWords
	"get languageStopWords"
	
	^ languageStopWords.! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 16:02'!
languageStopWords: aString
	"set languageStopWords: 'English' or 'Portuguese' "
	
	languageStopWords := aString.! !

!PCSPreprocessor methodsFor: 'preprocessing' stamp: 'FKP 11/17/2014 19:26'!
preprocess: aString
	| aBag treatedString Eng Port|
  "this method realizes comom preprocess methods over the String
	1- tokenizes the String 
    - may remove common words
    - capitalize tokens
    - may do stemming and lemmatization
	anArray := self tokenizer: aS. 
  "
	
	treatedString := self treatType: aString. 
	aBag := self tokenizer: aString. 
	
	removeStopWords ifTrue: 
						[ (languageStopWords = 'English') ifTrue: [Eng := PCSEnglishPreprocessor new.
																   ^self removeStopWords: Eng stopWords ofTokens: aBag.
																   ]. 
						  (languageStopWords = 'Portuguese') ifTrue: [Port := PCSPortuguesePreprocessor new.
																 ^self removeStopWords: Port stopWords ofTokens: aBag.
																].
						]
	ifFalse: [^aBag].! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 11:40'!
punctuation
	"get punctuation"

	^punctuation.! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 11:43'!
punctuation: aString
	"set punctuation, example '?!!.,:;()[]{}%$#+=' "
	
	punctuation := aString. ! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 15:55'!
removeStopWords
	"get removeStopWords"

	^removeStopWords.! !

!PCSPreprocessor methodsFor: 'accessing' stamp: 'FKP 11/17/2014 15:59'!
removeStopWords: aBoolean
	"set removeStopWords"

	removeStopWords := aBoolean.! !

!PCSPreprocessor methodsFor: 'preprocessing' stamp: 'FKP 11/17/2014 17:47'!
removeStopWords: aSetStopWords ofTokens: aBagTokens
	"remove aSetStopWords of aBagTokens"
	
	aSetStopWords do: [:stopword | aBagTokens do: 
							[:token | stopword = token ifTrue: 
										[aBagTokens remove: token]
							]
						 ].
					
	^aBagTokens.
	
	
	

	! !

!PCSPreprocessor methodsFor: 'preprocessing' stamp: 'FKP 11/17/2014 11:43'!
tokenizer: aString

|tokenizedString aBag|

tokenizedString := aString copyWithoutAll: punctuation.
tokenizedString translateToLowercase.
aBag := (tokenizedString substrings) asBag.
^aBag.



! !

!PCSPreprocessor methodsFor: 'preprocessing' stamp: 'TD 11/16/2014 13:31'!
treatType: aString
     " this method deals with different types of string"
	| filter tmpBag newString |
	(fileType = 'TXT') ifTrue: [
		^aString.
		].
	
	(fileType = 'HTML') ifTrue: [
		filter := FILTTextFilter new.
		"Remove HTML tags"
		tmpBag := filter filterText: aString between: '>' and: '<'.
		
		"Recontruct the string, keeping add spaces in the place of the old tags"
		newString := ''.
		tmpBag do:[ :word | newString := newString ,' ', word.].
		^newString.		
		].
	! !

!PCSProcessor methodsFor: 'counting' stamp: 'TD 10/28/2014 09:38'!
countIn: aString
	"return a Dictionary with the number of ocurrences of each word in aString"
	|aCollection  aSet aDictionary|
	aCollection := Array new.
	aSet := Set new.
	aDictionary := Dictionary new. 

	aCollection := aString  subStrings. 
	aSet := aCollection asSet.
	aSet do: [ :aSubString | aDictionary add: (Association key: aSubString value: (aCollection occurrencesOf: aSubString)).].

	 ^aDictionary! !

!PCSProcessor methodsFor: 'counting' stamp: 'FKP 11/17/2014 13:36'!
countIn: aString ocurrencesOf: aWord
	"return the number of ocurrences of aWord in aString"
	| n aBag tokenizedString pre|
	"aCollection := Bag new.
	finalCollection := Bag new. 
	aCollection := aString  subStrings. 
	aCollection do: [:word | ((word endsWithAnyOf: #('.' ',' '(' ')' '[' ']' '{' '}' ';' '$' '!!' '?')) & (word size > 1)) ifTrue: [word := word copyFrom: 1 to: (word size -1)].
							word translateToLowercase.
							finalCollection add: word].
	
	n := finalCollection occurrencesOf: (aWord asLowercase).
	^n."
	
	pre := PCSPreprocessor new.
	tokenizedString := aString copyWithoutAll: (pre punctuation).
	tokenizedString translateToLowercase.
	aBag := (tokenizedString substrings) asBag.
	n := aBag occurrencesOf: (aWord asLowercase).
	^n.! !

PCSProcessor subclass: #PCSStatisticsCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSStatisticsCalculator commentStamp: 'TD 11/16/2014 17:14' prior: 0!
PCSStatisticsCalculator is a class that calculates statistical measures of central tendency and dispersion, for a given generic collection. 

No selector key, the method applies to the absolute values of the collection and its usage is intuitive.

Already with the selector, the measure is calculated on the key value, for each element of the collection.

The key is a code block.

For instance, if you want the average width as an attribute. 
you can use the command:  
  pcs average: aCollection key: [ :x | x width].

Now, if you want the average occurrences of a word, you can do:
  pcs average: aCollection key: [ :x | x Countin: aword].


Instance Variables: none
!

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 9/27/2014 14:30'!
average: aCollection 
	"compute the average of the collection of real numbers"
	^aCollection average.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/7/2014 19:38'!
average: aCollection key: aKey
	"compute the average of key in the collection"
	| aNumberCollection |
	
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self average: aNumberCollection.! !

!PCSStatisticsCalculator methodsFor: 'tagging' stamp: 'FKP 11/15/2014 18:00'!
generateTags: aGODData
    "add tags to a GodData object
	this method has been deprecated
	The feature has been replaced by the class Tagger that uses Information Retrieval technics
	
	To tag all element of a collection, you should do as following
		pcsTagger = PCSTagger new.
		pcsTagger.tagCollection: aGODDataCollection.
	
	To tag an element, you should do as following:
		pcsTagger = PCSTagger new.
		pcsTagger.training: aGODDataCollection.
		pcsTagger.addTagsTo: aGODData.
    "

    |aString aCollection aDictionary|
    
    aDictionary := Dictionary new.
    aCollection := OrderedCollection new.
    aString := String new.
    aString := aGODData content.
    aDictionary := self countIn: aString.
    aCollection := (aDictionary associations asSortedCollection: [:x :y | x value > y value]) 
            collect: [:association | association key].
    
    aGODData tags add: (aCollection at: 1).
    aGODData tags add: (aCollection at: 2).
    aGODData tags add: (aCollection at: 3).! !

!PCSStatisticsCalculator methodsFor: 'initializing' stamp: 'TD 9/27/2014 13:35'!
initialize
	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:15'!
median: aCollection 
	"compute the median of the collection of Number"
	^aCollection median.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:15'!
median: aCollection key: aKey
	"compute the median of this key(k) in the collection(c)"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self median: aNumberCollection.

	! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:31'!
std: aCollection 
	"compute the standard deviation of the collection"
	
	^(self var: aCollection) sqrt.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:39'!
std: aCollection key: aKey
	"compute the standard deviation of key in the collection"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self std: aNumberCollection.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:42'!
var: aCollection 
	"compute the variance of the collection"
	|average sum|
	
	average := self average: aCollection.
	sum := 0.
	aCollection do: [:aNumber| sum := sum + ((aNumber - average) raisedTo: 2 ) ].
	
	^sum / aCollection size.! !

!PCSStatisticsCalculator methodsFor: 'averages_and_variances' stamp: 'TD 10/20/2014 14:30'!
var: aCollection key: aKey
	"compute the variance of the key in the collection"
	|aNumberCollection|
	aNumberCollection := Bag new: aCollection size.
	
	aCollection do: [ :each | aNumberCollection add: (aKey value: each) ].
	
	^self var: aNumberCollection.! !

PCSProcessor subclass: #PCSTagger
	instanceVariableNames: 'dictIdf minRelevance maxTf minTf numDocuments preprocessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessors'!

!PCSTagger commentStamp: 'FKP 11/2/2014 21:31' prior: 0!
A PCSTagger generates tags for GODData using your content. 

To this end, it counts with a variety of methods that enable it: 
do tokenization of strings, calculate the quantities tf-idf, organize the tokens in dictionaries tf-idf, and as the level of significance, generates tags for an element (GODData) or several (several GODData in a collection). 
To generate a tag, tf the respective token must belong to the interval [minTf, maxTf] desired;

The methods training, addTagsTo and tagCollection are specialized to deal with GODData.

How to use

  To tag all element of a collection

      pcsTagger = PCSTagger new.
      pcsTagger tagCollection: aGODDataCollection.

  To tag an element

      pcsTagger = PCSTagger new.
      pcsTagger training: aGODDataCollection.
      pcsTagger addTagsTo: aGODData.

Instance Variables
	
	dictIdf: an dictionary of idf; given a term t it returns the respective idf
	
	maxTf: define the max frequence to be considerated
		   * float in range [0..1]

	minTf: define the min frequence to be considerated
		   * float in range [0..1]
		
	minRelevance: define the min value of relevance that will be accepted as a tag
		   * float in range [0..1]

!

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'FKP 11/17/2014 19:47'!
countIn: aBag
	"return a Dictionary with the number of ocurrences of each word in aBag"
	|  aSet aDictionary|

	aSet := Set new.
	aDictionary := Dictionary new. 
	aSet := aBag asSet.
	aSet do: [ :aToken | 
		aDictionary add: (Association key: aToken value: (aBag occurrencesOf: aToken))
	].
	 ^aDictionary! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 10:55'!
createDictIdf: aStringCollection
  	|dictDf aBag|
  	numDocuments := aStringCollection size.
  	dictDf := Dictionary new.
	
  	"generates the dictionary of frequencies of each document"
  	aStringCollection do: [ :aElement |
		aBag := preprocessor  preprocess: aElement.
		aBag asSet do: [ :token |
			(dictDf includesKey: token)
				ifTrue:[
					dictDf at: token put: ((dictDf at: token) + 1)
				]
				ifFalse:[
					dictDf at: token put: 1
				].
      		
		]
    	].

  	"converte dict_df into a Inverse Document Frequency dictionary"
  	dictIdf := Dictionary new.
  	dictDf keysAndValuesDo: [ :token :freq |
    		dictIdf at: token put: (( numDocuments / (freq +1)) log)
  	].! !

!PCSTagger methodsFor: 'initialize-release' stamp: 'FKP 11/17/2014 13:37'!
createDictTf: aString
  	|aBag aDictTf|
	
  	" convert aString to an Bag of tokens"
  	aBag := preprocessor preprocess: aString.

  	" calculates number of ocourrences of each token"
  	aDictTf := self countIn: aBag.

   	^aDictTf! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:23'!
dictIdf
	"get dictIdf"
	^dictIdf.! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:27'!
dictIdf: value
	"set dictIdf"
	dictIdf := value.! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 11/16/2014 10:54'!
getMoreRelevantsOf: aString
 
	|dictTf tfIdfDict tfIdf minTfIdf maxTfIdf aBag tags|
	
	(self dictIdf isEmpty)
	ifTrue: [
		DictIdfMustNotBeEmpty signal
	].
  	dictTf :=  self createDictTf: aString.
	aBag := preprocessor preprocess: aString.
  	"calcula o tfidf de cada termo de aDict"
  	tfIdfDict := Dictionary new.
	
	minTfIdf := 1000.
	maxTfIdf := -1000.
  	dictTf keysAndValuesDo: [ :token :tf |
    		tfIdf := self tfIdf: token withFrequence: tf.
		tfIdfDict at: token put: tfIdf.
		
		"calculates the minTfIdf"
   		 (tfIdf < minTfIdf)
			ifTrue: [
      			minTfIdf := tfIdf.
    			].
		"calculates the maxTfIdf"
   		 (tfIdf > maxTfIdf)
			ifTrue: [
      			maxTfIdf := tfIdf.
    			].  		
		(((tf / aBag size) > self maxTf) | ((tf / aBag size) < self minTf)) 
			ifTrue: [
				dictTf removeKey: token.
			].
			
  	].
	
	"feature scaling, used to bring all values into the range [0,1]"
	 tfIdfDict keysAndValuesDo: [ :token :value |
		tfIdfDict at: token put: ((value - minTfIdf) / (maxTfIdf - minTfIdf)).
  	].
	"calcular minTfIdf e maxTfIdf"
	tags := Bag new.
  	tfIdfDict keysAndValuesDo: [ :token :value |
   		 (value > self minRelevance)
			ifTrue: [
      			tags add: token.
    			]
  	].
  	^tags.! !

!PCSTagger methodsFor: 'initialize-release' stamp: 'TD 11/16/2014 10:52'!
initialize

	"define a standard configuration to the algorithm"
	minRelevance := (0.8).
	minTf := (0.0).
	maxTf := (1.0).
	dictIdf := Dictionary new.
	preprocessor := PCSPreprocessor new.! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:24'!
maxTf
	"get maxTf"
	^maxTf. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:27'!
maxTf: value
	"set maxTf"
	maxTf := value. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:28'!
minRelevance
	"get minRelevance"
	^minRelevance. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:28'!
minRelevance: value
	"set minRelevance"
	minRelevance := value. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:27'!
minTf
	"get minTf"
	^minTf. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 10/30/2014 16:28'!
minTf: value
	"set minTf"
	minTf := value. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 11/16/2014 10:51'!
preprocessor
	"get preprocessor"
	^preprocessor. ! !

!PCSTagger methodsFor: 'accessing' stamp: 'TD 11/16/2014 10:51'!
preprocessor: value
	"set preprocessor"
	preprocessor := value. ! !

!PCSTagger methodsFor: 'as yet unclassified' stamp: 'TD 10/31/2014 12:31'!
tfIdf: aTerm withFrequence: aFrequence
	|idf|
	(dictIdf includesKey: aTerm)
		ifTrue: [	idf:= dictIdf at: aTerm.]
		ifFalse: [idf := ((numDocuments / 1) log). ].
	^(aFrequence * idf).! !
